%close all;
%clear all;
% % 
% % %TODOs before to run that demo add these three lines 
% % %to the classpath.txt file (which classpath.txt in matlab)
% % %and to the librarypath.txt (which librarypath.txt in matlab)
% % %# iCub YARP Matlab interface
% % /home/icub/software/src/yarp/bindings/build/jyarp
% % /home/icub/software/src/yarp/bindings/build/generated_src
% % /home/icub/software/src/yarp/bindings/build

%dynamic load does not work
%add the paths
%javaaddpath('/home/icub/software/src/yarp/bindings/build/jyarp');
%javaaddpath('/home/icub/software/src/yarp/bindings/build/generated_src');

%add the shared library
%addpath('/home/icub/software/src/yarp/bindings/build/generated_src');
%java.lang.System.load('/home/icub/software/src/yarp/bindings/build/libjyarp.so');


leftArmYarpIds = 0:15;
leftArmLabels = {'Shoulder pitch', 'Shoulder roll', 'Shoulder yaw', ...
    'Elbow', 'Wrist pronosupination', 'Wrist pitch', 'Wrist yaw', ...
    'Hand finger adduction/abduction', ...
    'Thumb opposition', 'Thumb proximal flexion/extension', 'Thumb distal flexion/extension', ...
    'Index proximal flexion/extension', 'Index distal flexion', ...
    'Middle proximal flexion/extension', 'Middle distal flexion', ...
    'Ring and little finger flexion'};

indexFingerYarpId = 12; %Index distal flexion

clc;

LoadYarp; % this loads the yarp library and initializes the network
%b = yarp.Bottle;
%b.fromString('hello from MATLAB')
options = yarp.Property;
options.put('device', 'remote_controlboard');
options.put('remote', '/icub/left_arm'); %iCubDarmstadt01
options.put('local', '/matlab/left');

robotDeviceLeft = yarp.PolyDriver(options);

if isequal(robotDeviceLeft.isValid,1)
    disp('[success] robot is available');
else
    disp('[warning] robot NOT available');
end

if isequal(robotDeviceLeft.isValid,1)
    
    posLeft = robotDeviceLeft.viewIPositionControl;
    encLeft = robotDeviceLeft.viewIEncoders();
    
    %number of joints
    nDOF = encLeft.getAxes();

    
    
    %read joint angles
    encodersLeft = yarp.DVector(nDOF);
    encLeft.getEncoders(encodersLeft);
    
    
    T = 200; %time steps %20 seconds
    
    thetas = zeros(1,T);
    
    figure;
    for t=1:T
        thetas(t) = encLeft.getEncoder(indexFingerYarpId);
        clf;
        stem(thetas(t));
        axis([0,2,-90,90]);
        ylabel('deg');
        legend(leftArmLabels(indexFingerYarpId));
        drawnow;
        pause(0.1);
    end

end

%methodsview(encodersLeft)




% if 1==0
%     theta = [-45 40 60 90 -45 -65 10 45 10 0 0 0 0 0 0 0]*180/pi;
%     home = yarp.DVector(nDOF);
%     encodersLeft = yarp.DVector(nDOF);
% 
%     for k=0:15
%         home.set(k,theta(k+11));
%     end
% 
%     posLeft.positionMove(home);
% end

robotDeviceLeft.close();




