%close all;
%clear all;

%from http://wiki.icub.org/wiki/Tactile_sensors_%28aka_Skin%29

clc;

fingerTipTaxelIds = 1:60;
fingerTipTaxelIds = reshape(fingerTipTaxelIds,12,5); %12 taxels per finger

LoadYarp;
import yarp.Port;
import yarp.Bottle;
import yarp.BufferedPortBottle;

localPortLHSkin=BufferedPortBottle; 
localPortLHSkin.close;
retVal=localPortLHSkin.open('/matlab/leftHandSkin');
if retVal
    disp '[success] port open';
else
    disp '[warning] port NOT open, is there a yarp server available (or save, wait and restart Matlab)?';
end

if yarp.Network.connect('/icub/skin/left_hand', '/matlab/leftHandSkin')
    disp '[success] port connected to /icub/skin/left_hand';
else
    disp '[warning] port NOT connected to /icub/skin/left_hand, does it exist?';
end


reply=Bottle;
figure;
for t = 1:500
    reply = localPortLHSkin.read(false);
    if (sum(size(reply)) ~= 0)
        %disp('received data ');
        %192 for hand data, where 1-60 are taxels of fingertips (12 each); 61-96 zeros; 97-144 palm taxels (inside these, 107, 119, 131, and 139 are thermal pads ~ 0s); 145-192 zeros. 
        sensorReadings = str2num(reply.toString_c());
        fingerTipRawValues = sensorReadings(fingerTipTaxelIds);
        clf;
        bar(min(fingerTipRawValues));
        axis([0,6,0,300]);
    end
    pause(0.001);
end

localPortLHSkin.close;
clear reply localPortLHSkin;

