%close all;
%clear all;
% % 
% % %TODOs before to run that demo add these three lines 
% % %to the classpath.txt file (which classpath.txt in matlab)
% % %and to the librarypath.txt (which librarypath.txt in matlab)
% % %# iCub YARP Matlab interface
% % /home/icub/software/src/yarp/bindings/build/jyarp
% % /home/icub/software/src/yarp/bindings/build/generated_src
% % /home/icub/software/src/yarp/bindings/build

%dynamic load does not work
%add the paths
%javaaddpath('/home/icub/software/src/yarp/bindings/build/jyarp');
%javaaddpath('/home/icub/software/src/yarp/bindings/build/generated_src');

%add the shared library
%addpath('/home/icub/software/src/yarp/bindings/build/generated_src');
%java.lang.System.load('/home/icub/software/src/yarp/bindings/build/libjyarp.so');


leftArmYarpIds = 0:15;
leftArmLabels = {'Shoulder pitch', 'Shoulder roll', 'Shoulder yaw', ...
    'Elbow', 'Wrist pronosupination', 'Wrist pitch', 'Wrist yaw', ...
    'Hand finger adduction/abduction', ...
    'Thumb opposition', 'Thumb proximal flexion/extension', 'Thumb distal flexion/extension', ...
    'Index proximal flexion/extension', 'Index distal flexion', ...
    'Middle proximal flexion/extension', 'Middle distal flexion', ...
    'Ring and little finger flexion'};

thumbFingerYarpIds = [8,9,10];
indexFingerYarpIds = [11,12];
middleFingerYarpIds = [13,14];
ringFingerYarpIds = [15];


clc;

LoadYarp; % this loads the yarp library and initializes the network
%b = yarp.Bottle;
%b.fromString('hello from MATLAB')
options = yarp.Property;
options.put('device', 'remote_controlboard');
options.put('remote', '/icub/left_arm'); %iCubDarmstadt01
options.put('local', '/matlab/left');

robotDeviceLeft = yarp.PolyDriver(options);

if isequal(robotDeviceLeft.isValid,1)
    disp('[success] robot is available');
else
    disp('[warning] robot NOT available');
end

if isequal(robotDeviceLeft.isValid,1)
    
    posLeft = robotDeviceLeft.viewIPositionControl;
    encLeft = robotDeviceLeft.viewIEncoders();
    
    %number of joints
    nDOF = encLeft.getAxes();

    %read joint angles
    encodersLeft = yarp.DVector(nDOF);
    encLeft.getEncoders(encodersLeft);
    if 1==0
        %TODO Shoulder pitch angle jumps
        theta = zeros(1,nDOF);
        for jointId=0:nDOF-1
            theta(1,jointId+1) = encLeft.getEncoder(jointId);
            pause(0.01);
        end
    else
        theta = [-30.0201416015625,30.0036621093750,0.0109863281249931,44.9505615234375,0.00732421875000286,6.86950496486816e-15,-6.86950496486816e-15,14.9154541015625,45.0739990234375,0.377421875000000,2.54140625000000,0.346181640625009,0.377587890625003,0.394619140625000,0.00925781250001800,1.05810546875001];
    end
    theta
   
    %move the whole arm
    if 1==0
        %encodersLeft.set(indexFingerYarpId, theta(indexFingerYarpId+1)+0.1);
        %posLeft.positionMove(encodersLeft);
    else
        %move only a single joint
        
        %thumb 'Thumb opposition', 'Thumb proximal flexion/extension', 'Thumb distal flexion/extension'
        posLeft.positionMove(thumbFingerYarpIds(1), 90);
        posLeft.positionMove(thumbFingerYarpIds(2), 0);
        posLeft.positionMove(thumbFingerYarpIds(3), 0);
        
        %index finger proximal and distal flexion
        posLeft.positionMove(indexFingerYarpIds(1), 30);
        posLeft.positionMove(indexFingerYarpIds(2), 0);
        
        %middle finger 
        posLeft.positionMove(middleFingerYarpIds(1), 0);
        posLeft.positionMove(middleFingerYarpIds(2), 0);
        
        %ring and middle finger
        posLeft.positionMove(ringFingerYarpIds, 0);
        
        
    end
    pause(2);
    %read encoders again
    encLeft.getEncoders(encodersLeft);
    thetaAfter = zeros(1,nDOF);
    for jointId=0:nDOF-1
        thetaAfter(1,jointId+1) = encLeft.getEncoder(jointId);
        pause(0.01);
    end
    
    [theta(thumbFingerYarpIds+1); thetaAfter(thumbFingerYarpIds+1)]
    
    %[theta(indexFingerYarpIds+1); thetaAfter(indexFingerYarpIds+1)]
    
    %[theta(middleFingerYarpIds+1); thetaAfter(middleFingerYarpIds+1)]
    %[theta(ringFingerYarpIds+1); thetaAfter(ringFingerYarpIds+1)]

    
    
end

%methodsview(encodersLeft)




% if 1==0
%     theta = [-45 40 60 90 -45 -65 10 45 10 0 0 0 0 0 0 0]*180/pi;
%     home = yarp.DVector(nDOF);
%     encodersLeft = yarp.DVector(nDOF);
% 
%     for k=0:15
%         home.set(k,theta(k+11));
%     end
% 
%     posLeft.positionMove(home);
% end

robotDeviceLeft.close();




